
/* 80188, no worry about alignment */

#include "head.h"
#include "pcb.h"

/* nihilistic */

static int
doprnt(ap, fmt, outfn, context)
	word *ap;
	byte *fmt;
	void (*outfn)(), *context;
{
	word cc = 0;
	word field, width, base;
	byte *p, *end, c, lpad, sign, leftjust;
	dword num;
	byte tmp[100];      /* not used by %s */

	for (;;) {
		while ((c = *fmt++) != '%') {
			if (c == 0)
				goto out;
	percent:
			(*outfn)(c, context);
			++cc;
		}
		if (*fmt == '%') {
			++fmt;
			goto percent;
		}

		/* flags
		 * field size
		 * . width (numbers: at least, strings: at most)
		 * length modifier 'ell'
		 * the conversion character */

		sign = leftjust = field = width = 0;
		lpad = ' ';

		for (;; ++fmt) {
			switch (*fmt) {
			case '0':
				lpad = '0';
				continue;

			case ' ':
			case '+':
				sign = *fmt;
				continue;

			case '-':
				leftjust = 1;
				continue;
			}
			break;
		}
		while (_isdigit(*fmt))
			field = field * 10 - '0' + *fmt++;

		if (*fmt == '.') {
			++fmt;
			while (_isdigit(*fmt))
				width = width * 10 - '0' + *fmt++;
		}
		if (*fmt == 'l') {
			++fmt;
			num = ((dword *) (ap += 2))[-1];
		} else
			num = (short) *ap++;     /* extend sign */

		p = end = &tmp[sizeof(tmp)]; /* "" if unknown conversion */

		switch (*fmt++) {
		case 0:
			goto out;

		case 'b':
			base = 2;
			goto number;
		case 'o':
			base = 8;
			goto number;
		case 'X':
		case 'x':
			base = 16;
			goto number;

		case 'd':
			if ((word) (num >> 16) & 0x8000) {
				sign = '-';
				num = -num;
			}
		case 'u':
			base = 10;
	number:
			p = format_num(num, base, p);
			if (width) {
				lpad = ' ';
				while (p + width > end)
					*--p = '0';          /* XXX limited space in tmp[] */
			}
			if (sign)
				*--p = sign;
			break;

		case 'c':
			*--p = (byte) num;
			break;

		case 's':
			p = (byte *) num;
			if (width) {
				end = memchr(p, 0, width);
				if (end == NULL)
					end = p + width;
			} else
				end = strend(p);
		}
		width = end - p;          /* can be 0 */

		if (width >= field) {
			cc += width;
			field = 0;
		} else {
			cc += field;
			field -= width;       /* never 0 */
			if (! leftjust) {
				do {
					(*outfn)(lpad, context);
				} while (--field);
			}
		}
		while (width--)
			(*outfn)(*p++, context);

		while (field--)
			(*outfn)(' ', context);
	}
out:
	if (outfn == putc_screen)
		update_cursor();

	return (cc);
}

static void
outstr(c, b)
	byte **b;
{
	*(*b)++ = c;
}

bprintf(pp, fmt, args)
	byte **pp, *fmt;
{
	return (doprnt(&args, fmt, outstr, pp));
}

sprintf(buf, fmt, args)
	byte *buf, *fmt;
{
	int cc = doprnt(&args, fmt, outstr, &buf);

	*buf = 0;
	return (cc);
}

fprintf(file, fmt, args)
	struct file *file;
	byte *fmt;
{
	return (doprnt(&args, fmt, file->putc, file));
}

fputc(c, file)
	struct file *file;
{
	(*file->putc)(c);
}

fputs(s, file)
	byte *s;
	struct file *file;
{
	while (*s)
		(*file->putc)(*s++);
}

long
scan_long(pp)
	byte **pp;
{
	byte *p = *pp;
	byte neg = 0;
	long x = 0;

	while (_isspace(*p) && *p)
		++p;

	if (*p == '-') {
		++p;
		neg = 1;
	}
	while (*p == '0')
		++p;

	while (_isdigit(*p))
		x = 10 * x + (*p++ - '0');

	*pp = p;

	return (neg ? -x : x);
}

#asm
	include asm.inc
	.text

;----------------------------------------------------------------------
	export _bzero, _memset, _bcopy, _bcmp
	export _strend, _strlen, _index, _rindex, _memchr
	export _strcmp, _strcpyx

_bcopy:
	mov si, ax
	ARG3 di, cx

	cmp si, di
	jb reverse
	shr cx, 1        ; forward then
	rep
	movsw
	rcl cx, 1        ; 0 or 1
	rep
	movsb
	ret

reverse:
	add si, cx
	add di, cx
	dec si          ; last byte
	dec di
	std
	shr cx, 1
	jnc rev_w
	movsb           ; last odd byte
rev_w:
	dec si          ; last whole word
	dec di
	rep
	movsw
	cld
	ret

_bzero:
	mov di, ax
	ARG2 cx
	xor ax, ax      ; word zero for stosw
	shr cx, 1
	rep
	stosw
	rcl cx, 1
	rep
	stosb
	ret

_memset:
	mov di, ax
	ARG3 al, cx
	mov ah, al      ; double the byte for stosw
	shr cx, 1
	rep
	stosw
	rcl cx, 1
	rep
	stosb
	ret

_strlen:
	mov di, ax
	mov al, # 0
	mov cx, # -1
	repne
	scasb
	mov ax, cx
	not ax
	dec ax
	ret

_strend:
	mov di, ax
	mov al, # 0
	mov cx, # -1
	repne
	scasb
	lea ax, [di-1]
	ret

_strcpyx:
	mov di, ax
	ARG2 si
L3:
	lodsb
	stosb
	or al, al
	jnz L3
	lea ax, [di-1]
	ret

_index:
	mov si, ax
	ARG2 ah
L1:
	lodsb
	cmp al, ah
	jz L2
	or al, al
	jnz L1
	xor ax, ax
	ret
L2:
	lea ax, [si-1]
	ret

_rindex:
	mov si, ax
	ARG2 ah
	mov bx, # 1          ; if none
L6:
	lodsb
	cmp al, ah
	jz L7                ; assume there are few matches
	or al, al
	jnz L6
	lea ax, [bx-1]
	ret
L7:
	mov bx, si           ; one match here
	or al, al
	jnz L6
	lea ax, [bx-1]
	ret

_memchr:
	mov di, ax
	ARG3 al, cx
	or ah, # 1          ; NZ
	repne
	scasb
	jnz zero
	lea ax, [di-1]
	ret

_bcmp:
	mov si, ax
	ARG3 di, cx
	xor ax, ax          ; Z and 0
	rep
	cmpsb               ; not expecting huge bytecounts
	jz zero
	inc ax              ; 1
	ret

_strcmp:
	mov si, ax
	ARG2 di
L4:
	lodsb
	scasb
	jnz plus_minus_one
	or al, al
	jz zero
	lodsb
	scasb
	jnz plus_minus_one
	or al, al
	jnz L4
zero:
	xor ax, ax
	ret
plus_minus_one:
	sbb ax, ax
	or al, # 1
	ret

;----------------------------------------------------------------------
	export _segment_address
	export _linear_address
	export _peekb
	export _peekw
	export _pokeb
	export _pokew
	export _exchangeb
	export _exchangew

_segment_address:     ; dword segment_address(dword linear);
	mov dx, ax        ; 2345
	and ax, # 15      ;    5
	and bx, # 15      ;    1
	ror bx, 4         ; 1000
	shr dx, 4         ; 0234
	add dx, bx        ; 0x1234:0x5 in dx:ax
	ret

_linear_address:      ; dword linear_address(word seg, word offs);
	ARG2 bx           ; offset
	rol ax, 4         ; segment 1234 to 2341
	mov dx, ax
	and dx, # 15      ;    1
	and al, # ~15     ; 2340
	add ax, bx        ; merge offset
	adc dx, # 0       ; 0x12345 in dxax
	ret

_peekb:               ; byte peekb(word seg, word offs);
	ARG2 bx
	push ds
	mov ds, ax
	mov al, [bx]
	pop ds
	mov ah, # 0
	ret

_peekw:               ; word peekw(word seg, word offs);
	ARG2 bx
	push ds
	mov ds, ax
	mov ax, [bx]
	pop ds
	ret

_pokeb:               ; void pokeb(word seg, word offs, byte);
	ARG3 bx, cl
	push ds
	mov ds, ax
	mov [bx], cl
	pop ds
	ret

_pokew:               ; void pokew(word seg, word offs, word);
	ARG3 bx, cx
	push ds
	mov ds, ax
	mov [bx], cx
	pop ds
	ret

_exchangeb:           ; byte exchangeb(byte new, word *where);
	ARG2 bx
	xchg [bx], al
	ret               ; return old

_exchangew:           ; word exchangew(word new, word *where);
	ARG2 bx
	xchg [bx], ax
	ret               ; return old

;----------------------------------------------------------------------
	export _crc_ccitt

_crc_ccitt:           ; word crc_ccitt(byte *, word);
	ARG2 cx           ; word cc
	mov bx, ax        ; byte *buffer

	mov dx, # 0x8408  ; poly
	mov ax, # 0xFFFF  ; iv
	call kirnu
	not ax            ; ~crc
	ret

kirnu:                ; ax=iv, bx=buffer, cx=count, dx=poly
	xor al, [bx]
	inc bx

	macro dobit
	shr ax, 1         ; 2 bytes, 2 cycles
	jnc * + 4         ; 2 bytes, 4/13 cycles
	xor ax, dx        ; 2 bytes, 3 cycles
	mend

	macro dobit_jmpless
	shr ax, 1         ;            2 bytes, 2 cycles
	sbb si, si        ; 0 or FFFF  2 bytes, 3? cycles
	and si, dx        ; 0 or poly  2 bytes, 3? cycles
	xor ax, si        ;            2 bytes, 3 cycles
	mend

	dobit
	dobit
	dobit
	dobit

	dobit
	dobit
	dobit
	dobit

	loop kirnu
	ret               ; ax=crc

;----------------------------------------------------------------------
; bases 2...36 work

	export _format_num

_format_num:               ; byte *format_num(dword bxax, word base, byte *ep)
	mov dx, bx             ; num in dxax
	ARG3 cx, di            ; num base and buffer end

	mov bx, cx             ; bases 2 ... 36 allowed
	dec bx
	and bx, cx
	jnz decimal            ; not power of 2

; shifts suffice

	dec cx                 ; 1 3 7 15 31
	mov si, cx
	shr si, 1              ; 0 1 3  7 15
L20:
	mov bx, cx
	and bx, ax
	mov bl, _hexdig[bx]    ; in case the base is 16 or 32
	dec di
	mov [di], bl

	or  ax, cx             ; bits to drop are 11111
	xor ax, si             ;  10000
L21:
	shr dx, 1
	rcr ax, 1
	jnc L21                ; XXX div 32 versus 4 jumps ?

	mov bx, dx
	or  bx, ax
	jnz L20

	mov ax, di
	ret

; use div

big:
	xchg bx, ax            ; lsword in bx, zero in ax
	xchg dx, ax            ; msword in dxax (dx 0)
	div cx
	xchg bx, ax            ; lsword <-> quotient msword
small:
	div cx
	xchg bx, dx            ; quotient in dxax, remainder in bx (bh 0)

	mov bl, _hexdig[bx]    ; in case the base is larger than 10
	dec di
	mov [di], bl           ; *--ep
decimal:
	xor bx, bx

	cmp dx, cx
	jae big                ; next quotient would not fit into ax
	cmp ax, cx
	jae small              ; lsword >= base
	cmp dx, bx
	jnz small              ; msword nonzero

	mov bx, ax
	mov bl, _hexdig[bx]
	dec di
	mov [di], bl

	mov ax, di             ; return address of msdigit
	ret

;----------------------------------------------------------------------
	export _setjmp
	export _longjmp

_setjmp:
	mov bx, ax          ; jb
	pop dx              ; ra
	xor ax, ax          ; rv
	mov [bx+0], ax      ; buf[0] zeroed just for fun
	mov [bx+2], dx      ; ip
	mov [bx+4], bp
	mov [bx+6], sp      ; sp last
	jmp dx

_longjmp:
	mov bx, ax          ; jb
	pop ax              ; ra, discard
	pop ax              ; rv
	mov dx, [bx+2]      ; ip
	mov bp, [bx+4]
	mov sp, [bx+6]
	jmp dx

;----------------------------------------------------------------------
	export _scale

_scale:               ; dword scale(dword ba, word m);
	push bp
	mov bp, sp
	mul [bp+4]        ; a * m
	mov cx, dx
	mov ax, bx
	mul [bp+4]        ; b * m
	add ax, cx
	adc dx, # 0
	pop bp
	ret               ; (dword * word) >> 16

	export _integer_root
	export _integer_hypot

#define mul_ax mul ax,ax   ; as86 rejects plain mul ax

_integer_hypot:       ; word integer_hypot(word x, word y);
	ARG2 cx
	or cx, cx
	jz ret_ax
	xchg ax, cx       ; how about the other ?
	or cx, cx
	jz ret_ax

	mul_ax
	xchg dx, bx       ; save to bxcx
	xchg ax, cx
	mul_ax
	add ax, cx
	adc bx, dx        ; sum in bxax
	jc overflow

_integer_root:        ; word integer_root(dword ba);
	mov di, bx
	mov si, ax

	xor cx, cx        ; accu
	mov bx, # 0x8000  ; try each bit
	or  di, di
	jnz root_1        ; more than 16 bits in
	test ax, # ~1     ; 0 or 1 ?
	jz  ret_ax
	xchg bl, bh       ; bx 0x80
root_1:
	mov ax, bx
	or  ax, cx
	mul_ax
	sub ax, si
	sbb dx, di
	ja  root_2        ; XXX check if equal ?
	or  cx, bx        ; accept the bit
root_2:
	shr bx, 1
	jnz root_1
	clc               ; if hypot()
	mov ax, cx
	ret

overflow:
	sbb ax, ax        ; return FFFF and carry if overflow
ret_ax:
	ret

;----------------------------------------------------------------------
	export _log2p1
	export _log2

_log2p1:
	add ax, # 1       ; XXX
	adc bx, # 0
	jnc _log2
	mov dx, # 32      ; 32.0
log_0:
	ret

_log2:
	mov dx, # 32
	test bx, bx
	jnz L11
	xchg bx, ax       ; bxax = ax << 16
	mov dl, # 16
	test bx, bx
	jnz L11
	mov dl, # 0       ; 0 for 0
	ret
L11:
	dec dx
	shl ax, 1         ; bxax <<= 1
	rcl bx, 1
	jnc L11           ; until msbit drops out and lsbits leftjust

	mov bl, bh             ; lookup fractional part
	mov bh, # 0
	mov ah, 1+log_tab[bx]  ; [i+1]
	test ah, ah
	jz L12                 ; [256] is 0, al stays as-is
	sub ah, log_tab[bx]
	mul ah
L12:
	add ah, log_tab[bx]
	ret

;----------------------------------------------------------------------
	export _far_bcmp
	export _far_bcopy

_far_bcmp:           ; int far_bcmp(dword src_lin, dword dst_lin, dword cc)
	push ds
	push es
	push bp          ; 0  2  4  6  8   12
	mov bp, sp       ; bp es ds ra dst cc

	mov si, ax       ; src, bxax
	ror bx, 4
	mov ds, bx       ; and dssi

	mov cx, [bp+10]  ; dst, cxdi
	mov di, [bp+8]
	ror cx, 4
	mov es, cx       ; and esdi

	mov dx, [bp+14]
	mov bx, [bp+12]  ; cc in dxbx

cmp_more:
	xor ax, ax       ; determine length of next chunk, into axcx
	mov cx, si
	cmp cx, di
	ja Lc_1
	mov cx, di       ; max of indexes
Lc_1:
	neg cx           ; carry, unless cx is and stays 0
	cmc
	rcl ax, 1        ; 0x10000 or less

	sub bx, cx
	sbb dx, ax
	jnc Lc_2         ; not last one
	add bx, cx
	adc dx, ax       ; undo
	mov cx, bx
	mov ax, dx       ; chunk = cc
	xor bx, bx
	xor dx, dx       ; and cc = 0
Lc_2:
	shr ax, 1
	rcr cx, 1        ; words, 0x8000 max
	rep
	cmpsw
	mov al, # 1      ; nonzero return value
	jnz cmp_diff
	rcl cx, 1        ; 0 or 1
	rep
	cmpsb
	jnz cmp_diff

	or si, si
	jnz Lc_3
	mov ax, ds
	add ax, # 0x1000
	mov ds, ax
Lc_3:
	or di, di
	jnz Lc_4
	mov ax, es
	add ax, # 0x1000
	mov es, ax
Lc_4:
	mov ax, bx
	or  ax, dx
	jnz cmp_more     ; ax 0, if nothing left
cmp_diff:
	leave
	pop es
	pop ds
	ret

;----------------------------------------------------------------------

_far_bcopy:          ; void far_bcopy(dword src_lin, dword dst_lin, dword cc)
	push ds
	push es
	push bp          ; 0  2  4  6  8   12
	mov bp, sp       ; bp es ds ra dst cc

	mov si, ax       ; src
	mov ax, bx       ;  axsi

	mov di, [bp+8]   ; dst
	mov cx, [bp+10]  ;  cxdi

	mov bx, [bp+12]  ; cc
	mov dx, [bp+14]  ;  dxbx

	cmp ax, cx
	ja far_bcopy_forward
	jb far_bcopy_reverse
	cmp si, di
	jb far_bcopy_reverse

far_bcopy_forward:
	ror ax, 4
	mov ds, ax       ; dssi
	ror cx, 4
	mov es, cx       ; esdi

loop_forw:
	xor ax, ax       ; determine length of next chunk, into axcx
	mov cx, si
	cmp cx, di
	ja L_1
	mov cx, di       ; max of indexes
L_1:
	neg cx           ; carry, unless cx is and stays 0
	cmc
	rcl ax, 1        ; 0x10000 or less

	sub bx, cx
	sbb dx, ax
	jnc L_2          ; not last one
	add bx, cx
	adc dx, ax       ; undo
	mov cx, bx
	mov ax, dx       ; chunk = cc
	xor bx, bx
	xor dx, dx       ; and cc = 0
L_2:
	shr ax, 1
	rcr cx, 1        ; words, 0x8000 max
	rep
	movsw
	rcl cx, 1        ; 0 or 1
	rep
	movsb

	or si, si
	jnz L_3
	mov ax, ds
	add ax, # 0x1000
	mov ds, ax
L_3:
	or di, di
	jnz L_4
	mov ax, es
	add ax, # 0x1000
	mov es, ax
L_4:
	mov ax, bx
	or  ax, dx
	jnz loop_forw    ; while something left

	jmp far_bcopy_done

far_bcopy_reverse:
	add si, bx       ; axsi cxdi dxbx
	adc ax, dx
	ror ax, 4
	mov ds, ax       ; dssi at end

	add di, bx
	adc cx, dx
	ror cx, 4
	mov es, cx       ; esdi at end

	std
loop_backw:
	sub si, # 1      ; last byte
	jnc Lb_3
	mov ax, ds
	sub ax, # 0x1000
	mov ds, ax
Lb_3:
	sub di, # 1
	jnc Lb_4
	mov ax, es
	sub ax, # 0x1000
	mov es, ax
Lb_4:
	xor ax, ax       ; determine length of next chunk, into axcx
	mov cx, si
	cmp cx, di
	jb Lb_1
	mov cx, di       ; min of indexes
Lb_1:
	add cx, # 1      ; sigh.
	adc ax, # 0      ; 0x10000 or less

	sub bx, cx
	sbb dx, ax
	jnc Lb_2         ; not last one
	add bx, cx
	adc dx, ax       ; undo
	mov cx, bx
	mov ax, dx       ; chunk = cc
	xor bx, bx
	xor dx, dx       ; and cc = 0
Lb_2:
	shr ax, 1
	rcr cx, 1        ; words, 0x8000 max
	jnc Lb_5
	movsb
Lb_5:
	dec si           ; last word
	dec di
	rep
	movsw
	inc si           ; back to "end"
	inc di

	mov ax, bx
	or  ax, dx
	jnz loop_backw   ; while something left

	cld
far_bcopy_done:
	leave
	pop es
	pop ds
	ret              ; whew.

;----------------------------------------------------------------------
	.data
;----------------------------------------------------------------------
	export _hexdig
	export _revbits
	export _bytemask
	export _wordmask
	export _pixmask
	export _pixmask_not

; upto base 36

_hexdig:
	.ascii "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ"

_wordmask:
	.word 0x0001, 0x0002, 0x0004, 0x0008, 0x0010, 0x0020, 0x0040, 0x0080
	.word 0x0100, 0x0200, 0x0400, 0x0800, 0x1000, 0x2000, 0x4000, 0x8000

_bytemask:
	.byte 0x01, 0x02, 0x04, 0x08, 0x10, 0x20, 0x40, 0x80

_pixmask:
	.byte 0x80, 0x40, 0x20, 0x10, 0x08, 0x04, 0x02, 0x01
_pixmask_not:
	.byte 0x7F, 0xBF, 0xDF, 0xEF, 0xF7, 0xFB, 0xFD, 0xFE

; left/right reversal

_revbits:
	.byte 0x00, 0x80, 0x40, 0xC0, 0x20, 0xA0, 0x60, 0xE0
	.byte 0x10, 0x90, 0x50, 0xD0, 0x30, 0xB0, 0x70, 0xF0
	.byte 0x08, 0x88, 0x48, 0xC8, 0x28, 0xA8, 0x68, 0xE8
	.byte 0x18, 0x98, 0x58, 0xD8, 0x38, 0xB8, 0x78, 0xF8
	.byte 0x04, 0x84, 0x44, 0xC4, 0x24, 0xA4, 0x64, 0xE4
	.byte 0x14, 0x94, 0x54, 0xD4, 0x34, 0xB4, 0x74, 0xF4
	.byte 0x0C, 0x8C, 0x4C, 0xCC, 0x2C, 0xAC, 0x6C, 0xEC
	.byte 0x1C, 0x9C, 0x5C, 0xDC, 0x3C, 0xBC, 0x7C, 0xFC
	.byte 0x02, 0x82, 0x42, 0xC2, 0x22, 0xA2, 0x62, 0xE2
	.byte 0x12, 0x92, 0x52, 0xD2, 0x32, 0xB2, 0x72, 0xF2
	.byte 0x0A, 0x8A, 0x4A, 0xCA, 0x2A, 0xAA, 0x6A, 0xEA
	.byte 0x1A, 0x9A, 0x5A, 0xDA, 0x3A, 0xBA, 0x7A, 0xFA
	.byte 0x06, 0x86, 0x46, 0xC6, 0x26, 0xA6, 0x66, 0xE6
	.byte 0x16, 0x96, 0x56, 0xD6, 0x36, 0xB6, 0x76, 0xF6
	.byte 0x0E, 0x8E, 0x4E, 0xCE, 0x2E, 0xAE, 0x6E, 0xEE
	.byte 0x1E, 0x9E, 0x5E, 0xDE, 0x3E, 0xBE, 0x7E, 0xFE
	.byte 0x01, 0x81, 0x41, 0xC1, 0x21, 0xA1, 0x61, 0xE1
	.byte 0x11, 0x91, 0x51, 0xD1, 0x31, 0xB1, 0x71, 0xF1
	.byte 0x09, 0x89, 0x49, 0xC9, 0x29, 0xA9, 0x69, 0xE9
	.byte 0x19, 0x99, 0x59, 0xD9, 0x39, 0xB9, 0x79, 0xF9
	.byte 0x05, 0x85, 0x45, 0xC5, 0x25, 0xA5, 0x65, 0xE5
	.byte 0x15, 0x95, 0x55, 0xD5, 0x35, 0xB5, 0x75, 0xF5
	.byte 0x0D, 0x8D, 0x4D, 0xCD, 0x2D, 0xAD, 0x6D, 0xED
	.byte 0x1D, 0x9D, 0x5D, 0xDD, 0x3D, 0xBD, 0x7D, 0xFD
	.byte 0x03, 0x83, 0x43, 0xC3, 0x23, 0xA3, 0x63, 0xE3
	.byte 0x13, 0x93, 0x53, 0xD3, 0x33, 0xB3, 0x73, 0xF3
	.byte 0x0B, 0x8B, 0x4B, 0xCB, 0x2B, 0xAB, 0x6B, 0xEB
	.byte 0x1B, 0x9B, 0x5B, 0xDB, 0x3B, 0xBB, 0x7B, 0xFB
	.byte 0x07, 0x87, 0x47, 0xC7, 0x27, 0xA7, 0x67, 0xE7
	.byte 0x17, 0x97, 0x57, 0xD7, 0x37, 0xB7, 0x77, 0xF7
	.byte 0x0F, 0x8F, 0x4F, 0xCF, 0x2F, 0xAF, 0x6F, 0xEF
	.byte 0x1F, 0x9F, 0x5F, 0xDF, 0x3F, 0xBF, 0x7F, 0xFF


; log2 from 1.0 to 2.0

log_tab:
	.byte 0x00, 0x01, 0x03, 0x04, 0x06, 0x07, 0x09, 0x0A
	.byte 0x0B, 0x0D, 0x0E, 0x10, 0x11, 0x12, 0x14, 0x15
	.byte 0x16, 0x18, 0x19, 0x1A, 0x1C, 0x1D, 0x1E, 0x20
	.byte 0x21, 0x22, 0x24, 0x25, 0x26, 0x28, 0x29, 0x2A
	.byte 0x2C, 0x2D, 0x2E, 0x2F, 0x31, 0x32, 0x33, 0x34
	.byte 0x36, 0x37, 0x38, 0x39, 0x3B, 0x3C, 0x3D, 0x3E
	.byte 0x3F, 0x41, 0x42, 0x43, 0x44, 0x45, 0x47, 0x48
	.byte 0x49, 0x4A, 0x4B, 0x4D, 0x4E, 0x4F, 0x50, 0x51
	.byte 0x52, 0x54, 0x55, 0x56, 0x57, 0x58, 0x59, 0x5A
	.byte 0x5C, 0x5D, 0x5E, 0x5F, 0x60, 0x61, 0x62, 0x63
	.byte 0x64, 0x66, 0x67, 0x68, 0x69, 0x6A, 0x6B, 0x6C
	.byte 0x6D, 0x6E, 0x6F, 0x70, 0x71, 0x72, 0x74, 0x75
	.byte 0x76, 0x77, 0x78, 0x79, 0x7A, 0x7B, 0x7C, 0x7D
	.byte 0x7E, 0x7F, 0x80, 0x81, 0x82, 0x83, 0x84, 0x85
	.byte 0x86, 0x87, 0x88, 0x89, 0x8A, 0x8B, 0x8C, 0x8D
	.byte 0x8E, 0x8F, 0x90, 0x91, 0x92, 0x93, 0x94, 0x95
	.byte 0x96, 0x97, 0x98, 0x99, 0x9A, 0x9B, 0x9B, 0x9C
	.byte 0x9D, 0x9E, 0x9F, 0xA0, 0xA1, 0xA2, 0xA3, 0xA4
	.byte 0xA5, 0xA6, 0xA7, 0xA8, 0xA9, 0xA9, 0xAA, 0xAB
	.byte 0xAC, 0xAD, 0xAE, 0xAF, 0xB0, 0xB1, 0xB2, 0xB2
	.byte 0xB3, 0xB4, 0xB5, 0xB6, 0xB7, 0xB8, 0xB9, 0xB9
	.byte 0xBA, 0xBB, 0xBC, 0xBD, 0xBE, 0xBF, 0xC0, 0xC0
	.byte 0xC1, 0xC2, 0xC3, 0xC4, 0xC5, 0xC6, 0xC6, 0xC7
	.byte 0xC8, 0xC9, 0xCA, 0xCB, 0xCB, 0xCC, 0xCD, 0xCE
	.byte 0xCF, 0xD0, 0xD0, 0xD1, 0xD2, 0xD3, 0xD4, 0xD4
	.byte 0xD5, 0xD6, 0xD7, 0xD8, 0xD8, 0xD9, 0xDA, 0xDB
	.byte 0xDC, 0xDC, 0xDD, 0xDE, 0xDF, 0xE0, 0xE0, 0xE1
	.byte 0xE2, 0xE3, 0xE4, 0xE4, 0xE5, 0xE6, 0xE7, 0xE7
	.byte 0xE8, 0xE9, 0xEA, 0xEA, 0xEB, 0xEC, 0xED, 0xEE
	.byte 0xEE, 0xEF, 0xF0, 0xF1, 0xF1, 0xF2, 0xF3, 0xF4
	.byte 0xF4, 0xF5, 0xF6, 0xF7, 0xF7, 0xF8, 0xF9, 0xF9
	.byte 0xFA, 0xFB, 0xFC, 0xFC, 0xFD, 0xFE, 0xFF, 0xFF

	.byte 0 ; special interpolation when [i+1] is 0

;----------------------------------------------------------------------
	.bss
;----------------------------------------------------------------------
