
#include "../h/param.h"
#include "../h/systm.h"
#include "../h/errno.h"
#include "../h/buf.h"
#include "../h/tty.h"
#include "../h/conf.h"
#include "../h/text.h"
#include "../h/dir.h"
#include "../h/file.h"
#include "../h/proc.h"
#include "../h/inode.h"
#include "../h/filsys.h"
#include "../h/mount.h"

int noop(), enodev();

int eestrategy(), eeread(), eewrite();
extern struct buf eetab;

int rdstrategy(), rdread(), rdwrite();
extern struct buf rdtab;

int	mmread(), mmwrite();
int	cnopen(), cnread(), cnwrite(), cnioctl(), cnclose();

struct bdevsw bdevsw[] = {
	{ noop,    noop,    eestrategy, &eetab }, /* eeprom disk */
	{ noop,    noop,    rdstrategy, &rdtab }, /* ram disk */
};
int nblkdev = __SIZEOF(bdevsw);

dev_t	rootdev	= makedev(0, 0); /* ee0 */
dev_t	argdev	= makedev(1, 0); /* rd0 */
dev_t	pipedev	= makedev(1, 0); /* rd0 */
 
struct cdevsw cdevsw[] = {
	{ noop,    noop,    mmread, mmwrite, enodev   }, /* null/mem */
	{ cnopen,  cnclose, cnread, cnwrite, cnioctl  }, /* console */
	{ noop,    noop,    eeread, eewrite, enodev   }, /* eeprom disk */
	{ noop,    noop,    rdread, rdwrite, enodev   }, /* ram disk */
};
int nchrdev = __SIZEOF(cdevsw);

int ttymaj = 128; /* pseudo-device /dev/tty */

struct	buf	bfreelist;
struct	buf	buf[NBUF];
 
struct	proc	proc[NPROC];
struct	text	text[NTEXT];
struct	file	file[NFILE];
struct	inode	inode[NINODE];
struct	mount	mount[NMOUNT];

