
#include "../h/param.h"
#include "../h/errno.h"
#include "../h/conf.h"
#include "../h/dir.h"
#include "../h/proc.h"
#include "../h/tty.h"
#include "../h/systm.h"
#include "../h/cons.h"

int	cnstart();

struct tty cons;

cnopen(dev, f_flag, istty)
	dev_t dev;
	int *istty;
{
	register struct tty *tp;

	tp = &cons;
	tp->t_oproc = cnstart;

	if ((tp->t_state&ISOPEN) == 0) {
		tp->t_state = ISOPEN|CARR_ON;
		tp->t_flags = ECHO|XTABS|CRMOD;
		ttychars(tp);
	}
	ttyopen(tp, dev, f_flag, istty);
}

cnclose(dev, f_flag)
	dev_t dev;
{
	ttyclose(&cons, f_flag);
}

cnread(dev, f_flag)
	dev_t dev;
{
	ttyread(&cons, f_flag);
}

cnwrite(dev, f_flag)
	dev_t dev;
{
	ttywrite(&cons, f_flag);
}

cnioctl(dev, cmd, arg, f_flag)
	dev_t dev;
{
	if (ttioccom(&cons, cmd, arg, f_flag) == 0)
		errno = ENOTTY;
}

/*
 * Got a level-20 transmission interrupt -
 * the LSI wants another character.  First,
 * see if we can send something to the typewriter.
 * If not, try the floppy.
 */
cnxint(dev)
	dev_t dev;
{
}

/*
 * Formerly cnxint -
 * called by new cnxint to see if there are
 * any characters to write to the console, and,
 * if there are, to do it.
 */
cnxtty()
{
	register struct tty *tp;

	tp = &cons;
	if (tp->t_outq.c_cc == 0)
		return(0);

	ttstart(tp);
	if (tp->t_outq.c_cc == 0 || tp->t_outq.c_cc == TTLOWAT)
		wakeup((caddr_t)&tp->t_outq);

	return(1);
}

/*
 * Got a level-20 receive interrupt -
 * the LSI wants to give us a character.
 * Catch the character, and see who it goes to.
 */
cnrint(dev)
	dev_t dev;
{
	register int c;

	ttyinput(&cons, c);	/* character from typewriter */
}

cnstart(tp, start)
	register struct tty *tp;
{
	register c;

	if (start) {
		if (0)
			return;
		if ((c=getc(&tp->t_outq)) >= 0) {
			c;
		}
	} else {
	}
}

/*
 * Print a character on console.
 */
putchar(c)
	register c;
{
	register s, timo;

	timo = 30000;
	/*
	 * Try waiting for the console tty to come ready,
	 * otherwise give up after a reasonable time.
	 */
	while (0)
		if (--timo == 0)
			break;
	if (c == 0)
		return;
	if (c == '\n')
		putchar('\r');
	putchar(0);
}

