
#include "../h/param.h"
#include "../h/systm.h"
#include "../h/dir.h"
#include "../h/buf.h"
#include "../h/proc.h"

/* 256 kB */
#define EEBASE 0x80000L
#define EESIZE 0x40000L

struct buf
	eetab,
	eerbuf;

eestrategy(bp)
	register struct buf *bp;
{
	if (minor(bp->b_dev) != 0
	 || bp->b_blkno < 0
	 || bp->b_blkno >= EESIZE / BSIZE
	 || bp->b_bcount % BSIZE) {
		bp->b_flags |= B_ERROR;
		iodone(bp);
		return;
	}
	bp->av_forw = NULL;

	eedoit(bp);
}

eeread(dev, f_flag)
	register dev;
{
	physio(eestrategy, &eerbuf, dev, B_READ, minphys);
}

eewrite(dev, f_flag)
	register dev;
{
	physio(eestrategy, &eerbuf, dev, B_WRITE, minphys);
}

eedoit(bp)
	register struct buf *bp;
{
	unsigned long baddr, count, eoff;

	eoff = bp->b_blkno << BSHIFT;

	count = bp->b_bcount;
	if (count > EESIZE - eoff)
		count = EESIZE - eoff;

	baddr = bp->b_un.b_addr;
	if (bp->b_flags & B_PHYS)
		baddr += ptob(bp->b_proc->p_ds);

	if (bp->b_flags & B_READ) {
		far_bcopy(EEBASE + eoff, baddr, count);
	} else {
		/* XXX magic sequences first */

			far_bcopy(baddr, EEBASE + eoff, count);
	}
	bp->b_resid = bp->b_bcount - count;
	iodone(bp);
}

