/*
 * Memory special file
 *	minor device 0 is EOF/RATHOLE
 *	minor device 1 is physical memory
 *	minor device 2 is kernel memory 
 */

#include "../h/param.h"
#include "../h/systm.h"
#include "../h/errno.h"
#include "../h/dir.h"
#include "../h/proc.h"
#include "../h/conf.h"
#include "../h/buf.h"

mmread(dev, f_flag)
{
	switch (minor(dev)) {

	case 0:
		return;

	case 1:
	case 2:
		if (copyout(u.u_offset, u.u_base, u.u_count))
			goto fault;

		u.u_base   += u.u_count;
		u.u_offset += u.u_count;
		u.u_count = 0;
		return;
	}
fault:
	errno = EFAULT;
}

mmwrite(dev, f_flag)
{
	switch (minor(dev)) {

	case 0:
		u.u_offset += u.u_count;
		u.u_count = 0;
		return;

	case 1:
	case 2:
		if (copyin(u.u_base, u.u_offset, u.u_count))
			goto fault;

		u.u_base   += u.u_count;
		u.u_offset += u.u_count;
		u.u_count = 0;
		return;
	}
fault:
	errno = EFAULT;
}

