
/* XXX add zero-length block to end */

/* simpleton. lots of splinters.
 * 188 means no alignment troubles */

#include "head.h"

void *malloc_sleepers;

/* free chunks are a list, ordered by memory address */

typedef
struct chunk {
	struct chunk *next;   /* first word */
	word size;
	/* and size - 4 bytes follow */
} chunk;

chunk *malloc_root;

#define ADDR(p) ((char *) (p))

void *
malloc(size)
	word size;
{
	register chunk **pp, *p;
	word rem;

	size += sizeof(word);                 /* storage for the saved size */
	if (size < sizeof(chunk))
		size = sizeof(chunk);

	for (pp = &malloc_root; p = *pp; pp = &p->next) {
		if (p->size >= size) {
			rem = p->size - size;

			if (rem < sizeof(chunk)) {
				size = p->size;
				*pp = p->next;            /* give it all */
			} else {
				*pp = (void *) (ADDR(p) + size);
				(*pp)->next = p->next;
				(*pp)->size = rem;
			}
			*(word *) p = size;           /* stored below user data */
			return ((word *) p + 1);
		}
	}
	return (NULL);
}

void
free(ptr)
	void *ptr;
{
	register chunk **pp, *p;
	chunk *q;

	q = (void *) ((word *) ptr - 1);
	q->size = *(word *) q;
	q->next = NULL;

	for (pp = &malloc_root; p = *pp; pp = &p->next) {
		if (q < p) {
			q->next = p;

			if (ADDR(q) + q->size == ADDR(p)) {
				q->size += p->size;
				q->next = p->next;        /* merge with next */
			}
			break;
		}
	}
	p = (void *) pp;
	if (pp != &malloc_root && ADDR(p) + p->size == ADDR(q)) {
		p->size += q->size;
		p->next = q->next;          /* merge with previous */
	} else
		*pp = q;
}

void
free_wake(ptr)
	void *ptr;
{
	free(ptr);

	if (malloc_sleepers)
		wakeup(&malloc_sleepers);   /* XXX might be a false alarm */
}

void *
malloc_wait(size)
{
	void *ptr;

	while ((ptr = malloc(size)) == NULL)
		sleep(&malloc_sleepers);

	return (ptr);
}

void
give_to_malloc(ptr, size)
	void *ptr;
	word size;
{
	if (size > sizeof(chunk)) {
		*(word *) ptr = size;
		free((word *) ptr + 1);
	}
}

