
/* 80C188XL */

/* XXX oddity in PCB register writes */

#define PCB_AX al

#define PCB(off) (0xFF00 + (off))

/* interrupt controller */
#define EOI    PCB(0x22)
#define IMASK  PCB(0x28)
#define IPRIO  PCB(0x2A)
#define INSVC  PCB(0x2C)
#define IREQ   PCB(0x2E)
#define ISTAT  PCB(0x30)
#define TICON  PCB(0x32)
#define D0ICON PCB(0x34)
#define D1ICON PCB(0x36)
#define I0CON  PCB(0x38)
#define I1CON  PCB(0x3A)
#define I2CON  PCB(0x3C)
#define I3CON  PCB(0x3E)

/* timer 0 */
#define T0CNT  PCB(0x50)
#define T0CMP  PCB(0x52)
#define T0CMPB PCB(0x54)
#define T0MODE PCB(0x56)

/* timer 1 */
#define T1CNT  PCB(0x58)
#define T1CMP  PCB(0x5A)
#define T1CMPB PCB(0x5C)
#define T1MODE PCB(0x5E)

/* timer 2 */
#define T2CNT  PCB(0x60)
#define T2CMP  PCB(0x62)
#define T2MODE PCB(0x66)

/* chip-select control */
#define UMCS   PCB(0xA0)
#define LMCS   PCB(0xA2)
#define PACS   PCB(0xA4)
#define MMCS   PCB(0xA6)
#define MPCS   PCB(0xA8)

/* dma 0 */
#define D0SRCL PCB(0xC0)
#define D0SRCH PCB(0xC2)
#define D0DSTL PCB(0xC4)
#define D0DSTH PCB(0xC6)
#define D0CNT  PCB(0xC8)
#define D0CON  PCB(0xCA)

/* dma 1 */
#define D1SRCL PCB(0xD0)
#define D1SRCH PCB(0xD2)
#define D1DSTL PCB(0xD4)
#define D1DSTH PCB(0xD6)
#define D1CNT  PCB(0xD8)
#define D1CON  PCB(0xDA)

/* pcb relocation register */
#define RELREG PCB(0xFE)

/* pcs base addresses, PCS0 determined by PACS */
#define PCS0   0                /* asic */
#define PCS1   (PCS0 + 0x080)
#define PCS2   (PCS0 + 0x100)
#define PCS3   (PCS0 + 0x180)   /* crtc */
#define PCS4   (PCS0 + 0x200)
#define PCS5   (PCS0 + 0x280)   /* one poor outb(0x2e9, 0) exists */
#define PCS6   (PCS0 + 0x300)   /* strange long write to 0x33e et al */

#define EOI_TMR  0x0008
#define EOI_DMA0 0x000A
#define EOI_DMA1 0x000B
#define EOI_INT0 0x000C
#define EOI_INT1 0x000D
#define EOI_INT2 0x000E
#define EOI_INT3 0x000F
#define EOI_ANY  0x8000

