
	.module cclib

	.area _CODE

;----------------------------------------------------------------------
;----------------------------------------------------------------------
; shiftcount currently always 1 or 2

__rrslong_rrx_s:          ; long rrslong(long, byte);
	pop af
	pop hl
	pop de
	pop bc                ; byte shiftcount (0 ... 32)
	push bc
	push de
	push hl
	push af

	dec c
	ret m
1$:
	sra d
	rr e
	rr h
	rr l
	dec c
	jp p, 1$

	ret

__rrulong_rrx_s::         ; dword rrulong(dword, byte);
	pop af
	pop hl
	pop de
	pop bc                ; byte shiftcount (0 ... 32)
	push bc
	push de
	push hl
	push af

	dec c
	ret m
1$:
	srl d
	rr e
	rr h
	rr l
	dec c
	jp p, 1$

	ret

__rlslong_rrx_s::
__rlulong_rrx_s::         ; dword rlulong(dword, byte);
	pop af
	pop hl
	pop de
	pop bc                ; byte shiftcount (0 ... 32)
	push bc
	push de
	push hl
	push af

	dec c
	ret m
1$:
	add hl, hl
	rl e
	rl d
	dec c
	jp p, 1$

	ret

;----------------------------------------------------------------------
; HL * HL'       DEHL
; HL * DE'     DEHL   msword discarded
; DE * HL'     DEHL   msword discarded
; DE * DE'   DEHL     discarded

__mullong_rrx_s::         ; dword mullong(dword, dword);
	ld iy, # 2
	add iy, sp

	ld l, 0(iy)           ; HL
	ld h, 1(iy)
	ld c, 6(iy)           ; DE'
	ld b, 7(iy)
	call mul_hl_bc        ; 1st mspart
	push hl

	ld l, 2(iy)           ; DE
	ld h, 3(iy)
	ld c, 4(iy)           ; HL'
	ld b, 5(iy)
	call mul_hl_bc        ; 2nd mspart
	push hl

	ld l, 0(iy)           ; HL
	ld h, 1(iy)
	ld c, 4(iy)           ; HL'
	ld b, 5(iy)
	call mul_hl_bc        ; lspart
	ex de, hl             ; HLDE
	pop bc                ; mspart
	add hl, bc
	pop bc                ; another
	adc hl, bc
	ex de, hl             ; DEHL

	ret

;----------------------------------------------------------------------

__divuschar_rrx_s::
	pop af
	pop bc                ; dividend C (signed) divisor B (unsigned)
	push bc
	push af

	ld d, # 0
	ld e, b               ; divisor DE
	ld b, d               ; divided BC, if 0 ... 255

	ld a, c
	or a
	jp p, div             ; positive dividend, positive result

	neg
	ld c, a               ; dividend BC
	call div
	jp neg                ; negative divided, negative result

;----------------------------------------------------------------------

__divuint_rrx_s::         ; word divuint(word, word);
	pop af
	pop bc                ; dividend
	pop de                ; divisor
	push de
	push bc
	push af

div:
	ld hl, # 0            ; remainder

	ld a, b               ; msbyte of dividend/quotient
	ld b, # 8
2$:
	rla
	adc hl, hl
	sbc hl, de
	jr nc, 1$
	add hl, de
1$:
	djnz 2$

	ld b, a               ; exchange A and C
	ld a, c               ; lsbyte of dividend/quotient
	ld c, b
	ld b, # 8
4$:
	rla
	adc hl, hl
	sbc hl, de
	jr nc, 3$
	add hl, de
3$:
	djnz 4$

	rla
	cpl                   ; carry not affected
	ld l, a
	ld a, c
	rla
	cpl
	ld h, a
	ret

;----------------------------------------------------------------------

	.IF 0

__divulong_rrx_s::        ; dword divulong(dword, dword);

	.ENDIF

;----------------------------------------------------------------------
