
/* XXX partly duplicated in cfg.inc */

#define MAGIC 0xD89B9ED2

typedef byte cfg_string[11];
typedef byte cfg_boolean;
typedef byte cfg_table;

struct cfg {
	dword magic;                 /* 0 */
	word size;                   /* 4 */

	dword rx_freq;               /* 6 */
	dword tx_offset;             /* 10 */

	byte volume;                 /* 14 */
	cfg_table af_dest;           /* 15 */

	byte tpc;                    /* 16 */
	byte deviation;              /* 17 XXX _4_ bits in synth control 4094 */
	byte dtmf_gain;              /* 18 */
	byte ccir_gain;              /* 19 */
	byte afsk_gain;              /* 20 */
	byte ctcss_gain;             /* 21 */
	word ctcss;                  /* 22 */

	byte sql_level;              /* 24 */
	byte sql_bi_rssi;            /* 25 */
	byte sql_hyst;               /* 26 */
	word sql_open;               /* 27 */
	word sql_close;              /* 29 */
	cfg_table sql_method;        /* 31 */

	word lights;                 /* 32 */

	cfg_boolean sql_light;       /* 34 */
	word ax_txdelay;             /* 35 */

	cfg_string mycall;           /* 37 */
	cfg_string id;               /* 48 */

	cfg_table sio_a_fmt;         /* 59 */
	cfg_table sio_b_fmt;         /* 60 */

	cfg_boolean fdx;             /* 61 */
	cfg_boolean stay_on;         /* 62 */
	cfg_table dtmf_decoder;      /* 63 */

	dword tx_band_start;         /* 64 */
	dword tx_band_end;           /* 68 follows band_start */
	dword rx_band_center;        /* 72 */
	dword tx_band_center;        /* 76 */
	long if_offset;              /* 80 */
	word prescaler;              /* 84 */

	word batt_cutoff;            /* 86 */

	word implied;                /* 88 */

	word lpf_tx;                 /* 90 */
	word lpf_rx;                 /* 92 */

	cfg_table synthesizer;       /* 94 */
	byte morse_cpm;              /* 95 */
	word morse_Hz;               /* 96 */

	word dtmf_speed;             /* 98 */
	word dcs;                    /* 100 */

	word up_down;                /* 102 */
	word max_over;               /* 104 */

	cfg_boolean satellite;       /* 106 */
	byte dB_zero;                /* 107 */
	byte dB_scale;               /* 108 */
};

extern struct cfg cfg; /* 0xC100 abs */

extern byte
	bbram[],           /* 0xC010, 0xF0 bytes */
	cfg_START[],
	cfg_END[],
	rfc_table[256],    /* 0xCF00 */
	bbend[];           /* 0xD000 */

extern const word cfg_size;

extern void
	new_defaults(),
	full_reset();

/* ad_batt: 5v REF, 100k and 47k divider */

#define millivolt(ad) ((ad) * 61U)

struct memory {
	byte  flags;
	byte  reserved;
	word  ctcss;
	dword rx_freq;     /* msbits reserved */
	dword tx_offset;   /* msbits reserved */
};

#ifdef L8M
#define N_MEMORIES 40  /* 2kB EEPROM */
#else
#define N_MEMORIES 100 /* 4kB bbram */
#endif

extern struct memory memories[N_MEMORIES]; /* 0xCA00 */

enum {
	SYNTH_S8D,
	SYNTH_S8C,
	SYNTH_COMPUTEC,
	SYNTH_S8M_12,
	SYNTH_S8M_10,
};

