
/* for L8M
 *
 * iomap_L8M.inc is a subset of this file */

IO_ADDR(PIO_A_DATA, 0x00)
IO_ADDR(PIO_B_DATA, 0x01)
IO_ADDR(PIO_A_CTRL, 0x02)
IO_ADDR(PIO_B_CTRL, 0x03)
IO_ADDR(SIO_A_DATA, 0x10)
IO_ADDR(SIO_B_DATA, 0x11)
IO_ADDR(SIO_A_CSR,  0x12)
IO_ADDR(SIO_B_CSR,  0x13)
IO_ADDR(TMR_BRG,    0x20)
IO_ADDR(TMR_LPF,    0x21)
IO_ADDR(TMR_MT,     0x22)
IO_ADDR(TMR_CTRL,   0x23)
IO_ADDR(DA_TPC,     0x30) /* double duty as DA_RFC */
IO_ADDR(DA_RFC,     0x30) /* same address */
IO_ADDR(AD_RSSI,    0x40)
IO_ADDR(AD_FPM,     0x41)
IO_ADDR(AD_BATT,    0x42)
IO_ADDR(AD_TPC,     0x43)
IO_ADDR(AD_RPM,     0x44)
IO_ADDR(AD_TP4,     0x45)
IO_ADDR(AD_IN7,     0x46)
IO_ADDR(AD_SQL,     0x47)
IO_ADDR(OUT_1,      0x50) /* == OUT_2 */
IO_ADDR(OUT_2,      0x50) /* OUT0 in manual */
IO_ADDR(OUT_0,      0x60) /* OUT1 in manual, works as P8x OUT0 */
IO_ADDR(WDOG,       0x70)

extern byte
	out_0,
	out_1, /* out_1 == out_2 */
	out_2;

#define O0_VOLUME 0x07 /* speaker volume */
#define O0_INH    0x08 /* speaker off */
#define O0_AUDIOC 0x10
#define O0_CCIRC  0x20
#define O0_MTC    0x40
#define O0_MICM   0x80

/* mimic P8x */

#define O2_DP     0x01 /* aka O1_SD  */
#define O2_CLK    0x02 /* aka O1_CLK */
#define O1_SRE    0x04 /* positive pulse loads (?) */
#define O1_STE    0x08 /* NEGATIVE edge loads, negative enables vco */
#define O2_CS1    0x10
#define O2_CS2    0x20
#define O1_TPS    0x40 /* power select 2.5w or 25w. same pin as RFS */
#define O1_TXOFF  0x80
#define O1_TXON   0x00 /* dummy */

#define O1_CLK O2_CLK
#define O1_SD  O2_DP


#define SA_ONHOOK RR0_DCD
#define SA_DA     RR0_CTS	/* DA or I2C /INT */

/* correct ? */
#define SA_nRXE   WR5_DTR	/* fsk modem RXE. inversion in sio accounted for */
#define SA_TXE    WR5_RTS	/* fsk modem /TXE */

#define SB_PTT    RR0_CTS
#define SB_LOCAL  RR0_SYNC
#define SB_DMIDLE RR0_DCD	/* 1 means MBUS idle */

#define SB_MON    WR5_DTR   /* Master ON pulse, a/c coupled */


#define PA_CLK2    0x01  /* 1968.75 Hz square wave      */
#define PA_SLOCKBE 0x02  /* out_1=buffer_disable, in_0=pll_locked */
#define PA_WDR     0x04  /* watchdog was activated      */
#define PA_PWR     0x08  /* on/off button, 1 means off  */
#define PA_CCIR    0xF0  /* FX003 data                  */

#define PB_EEA10  0x01	/* of EEPROM               out               */
#define PB_EXIN1  0x02	/* aka /POR                out 0 if SERV     */
#define PB_EXIN2  0x04  /* aka /IGN aka /EMG       out 0 if GPio2b 0 */
#define PB_DCU    0x08	/* I2C SDA for CU58AF      out 0 if SDA 0    */
#define PB_ROM_SL 0x10  /* ROM1 A14 ?              out               */
#define PB_SMEM   0x20  /* RAM=1 EEPROM=0          out               */
#define PB_EXAL   0x40	/*                         out               */
#define PB_PWROFF 0x80	/*                         out               */

/* all gates are +5v */

#define TMR_SEL_BRG  0x00
#define TMR_SEL_LPF  0x40
#define TMR_SEL_MT   0x80

